VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Gnrateur de coefficients / Factors generator"
   ClientHeight    =   8505
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   15240
   LinkTopic       =   "Form1"
   ScaleHeight     =   8505
   ScaleWidth      =   15240
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton BTversion 
      Caption         =   "QR code Version "
      Height          =   375
      Left            =   120
      TabIndex        =   14
      Top             =   6960
      Width           =   1455
   End
   Begin VB.CommandButton BTformat 
      Caption         =   "QR code Format"
      Height          =   375
      Left            =   120
      TabIndex        =   13
      Top             =   6360
      Width           =   1455
   End
   Begin VB.CommandButton BTQRtest 
      Caption         =   "QR 10 cw"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   5280
      Width           =   1455
   End
   Begin VB.CommandButton BTDMtest 
      Caption         =   "DM 10 cw"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   4680
      Width           =   1455
   End
   Begin VB.TextBox COardoise 
      Appearance      =   0  'Flat
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7935
      Left            =   1800
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   360
      Width           =   16335
   End
   Begin VB.CommandButton BTPDFtest 
      Caption         =   "PDF 8 cw"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   4080
      Width           =   1455
   End
   Begin VB.CommandButton BTfin 
      Caption         =   "Fermer / Close"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   7920
      Width           =   1455
   End
   Begin VB.CommandButton BTpdf417 
      Caption         =   "PDF 417"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   1455
   End
   Begin VB.CommandButton BTdatamatrix 
      Caption         =   "Datamatrix"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   1560
      Width           =   1455
   End
   Begin VB.CommandButton BTqrcode 
      Caption         =   "QR code"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   2160
      Width           =   1455
   End
   Begin VB.Label Label5 
      Caption         =   "Factors computing"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label Label4 
      Caption         =   "Calcul des coef."
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   360
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Calcul des MC de correction"
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   3120
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "Error CW calculation"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   3600
      Width           =   1575
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Rsultats"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1800
      TabIndex        =   5
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim TLog(256), TAlog(256)

Private Sub BTfin_Click()
  Unload Me
End Sub

Private Sub BTpdf417_Click()
  Dim Size%, Pow%, k%, i%, j%
  COardoise = ""
  For k% = 0 To 8  '8 niveau de correction / 8 correction range
    Size% = 2 ^ (k% + 1) 'Le nombre de MC de correction / the number of error-correction codeword
    ReDim Coef(Size%)
    Coef(0) = 1
    Pow% = 1
    For i% = 1 To Size%
      Pow% = Pow% * 3 Mod 929 '= 3^i(MOD 929)
      Coef(i%) = 0
      For j% = i To 1 Step -1
        Coef(j%) = (Coef(j% - 1) - Pow% * Coef(j%)) Mod 929
      Next
      Coef(0) = -Coef(0) * Pow% Mod 929
    Next
    For i% = 0 To Size% - 1
      Coef(i%) = (Coef(i%) + 929) Mod 929
      'Affichage / Display
      COardoise = COardoise & Coef(i%) & " "
    Next
    COardoise = COardoise & vbCrLf & vbCrLf
  Next
End Sub

Private Sub BTdatamatrix_Click()
  Dim SizeList$, SizeNb%, Size%, Pow%, k%, i%, j%
  COardoise = ""
  SizeList$ = "05,07,10,11,12,14,18,20,24,28,36,42,48,56,62,68"
  SizeNb% = Len(SizeList$) / 3
  Call SetLog(301)
  For k% = 1 To SizeNb%
    Size% = Mid$(SizeList$, k% * 3 - 2, 2)  'Le nombre de MC de correction / the number of error-correction codeword
    ReDim Coef(Size% - 1)
    Pow% = 1
    For i% = 1 To Size%
      Pow% = Mult(Pow%, 2)
      Coef(i% - 1) = 1
      For j% = i% - 1 To 0 Step -1
        Coef(j%) = Mult(Coef(j%), Pow%)
        If j% > 0 Then Coef(j%) = Coef(j%) Xor Coef(j% - 1)
      Next
    Next
    'Affichage / Display
    For i% = 0 To Size% - 1
      COardoise = COardoise & Coef(i%) & " "
    Next
    COardoise = COardoise & vbCrLf & vbCrLf
  Next
End Sub

Private Sub BTqrcode_Click()
  Dim SizeList$, SizeNb%, Size%, Pow%, k%, i%, j%
  COardoise = ""
  SizeList$ = "02,05,06,07,08,10,13,14,15,16,17,18,20,22,24,26,28,30,32,34,36,40,42,44,46,48,50,52,54,56,58,60,62,64,66,68"
  SizeNb% = Len(SizeList$) / 3
  Call SetLog(285)
  For k% = 1 To SizeNb%
    Size% = Mid$(SizeList$, k% * 3 - 2, 2)  'Le nombre de MC de correction / the number of error-correction codeword
    ReDim Coef(Size% - 1)
    Pow% = 1
    For i% = 1 To Size%
      Coef(i% - 1) = 1
      For j% = i% - 1 To 0 Step -1
        Coef(j%) = Mult(Coef(j%), Pow%)
        If j% > 0 Then Coef(j%) = Coef(j%) Xor Coef(j% - 1)
      Next
      Pow% = Mult(Pow%, 2)
    Next
    'Affichage / Display
    For i% = 0 To Size% - 1
      COardoise = COardoise & Coef(i%) & "  "
    Next
    COardoise = COardoise & vbCrLf & vbCrLf
  Next
End Sub

Private Sub BTPDFtest_Click()
  Dim ChaineMC$, CoefRS$, Longueur%, NbRS%, i%, j%, Total%
  COardoise = "Chaine pour le mot 'Hello' / String for the 'Hello' word : '004 237 131 344'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des coefficients / Factors string : '237 308 436 284 646 653 428 379'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des MC de correction / Error correction CW string : "
  ChaineMC$ = "004 237 131 344"
  CoefRS$ = "237 308 436 284 646 653 428 379"
  Longueur% = Len(ChaineMC$) / 4
  NbRS% = Len(CoefRS$) / 4
  ReDim MCcorrection%(NbRS% - 1)
  Total% = 0
  For i% = 0 To Longueur% - 1
    Total% = (Mid$(ChaineMC$, i% * 4 + 1, 3) + MCcorrection%(NbRS% - 1)) Mod 929
    For j% = NbRS% - 1 To 0 Step -1
      If j% = 0 Then
        MCcorrection%(j%) = (929 - (Total% * Mid$(CoefRS$, j% * 4 + 1, 3)) Mod 929) Mod 929
      Else
        MCcorrection%(j%) = (MCcorrection%(j% - 1) + 929 - (Total% * Mid$(CoefRS$, j% * 4 + 1, 3)) Mod 929) Mod 929
      End If
    Next
  Next
  For j% = 0 To NbRS% - 1
    If MCcorrection%(j%) <> 0 Then MCcorrection%(j%) = 929 - MCcorrection%(j%)
  Next
  For i% = NbRS% - 1 To 0 Step -1
    COardoise = COardoise & Format(MCcorrection%(i%), "000") & " "
  Next
End Sub

Private Sub BTDMtest_Click()
  Dim ChaineMC$, CoefRS$, Longueur%, NbRS%, i%, j%, Total%
  COardoise = "Chaine pour le mot 'Hello' / String for the 'Hello' word : '230 131 150 254 109 109 112 129'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des coefficients / Factors string : '028 024 185 166 223 248 116 255 110 061'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des MC de correction / Error correction CW string : "
  Call SetLog(301)
  ChaineMC$ = "230 131 150 254 109 109 112 129"
  CoefRS$ = "028 024 185 166 223 248 116 255 110 061"
  NbRS% = Len(CoefRS$) / 4
  ReDim MCcorrection%(NbRS% - 1)
  Total% = 0
  For i% = 0 To Len(ChaineMC$) / 4 - 1
    Total% = Mid$(ChaineMC$, i% * 4 + 1, 3) Xor MCcorrection%(NbRS% - 1)
    For j% = NbRS% - 1 To 0 Step -1
      'Multiplication dans un champ de Galois / Galois field multiplication
      If Total% = 0 Then
        MCcorrection%(j%) = 0
      Else
        MCcorrection%(j%) = Mult(Total%, Mid$(CoefRS$, j% * 4 + 1, 3))
      End If
      If j% > 0 Then MCcorrection%(j%) = MCcorrection%(j%) Xor MCcorrection%(j% - 1)
    Next
  Next
  For i% = NbRS% - 1 To 0 Step -1
    COardoise = COardoise & Format(MCcorrection%(i%), "000") & " "
  Next
End Sub

Private Sub BTQRtest_Click()
  Dim ChaineMC$, CoefRS$, Longueur%, NbRS%, i%, j%, Total%
  COardoise = "Chaine pour le mot '01234567' / String for the '01234567' word : '016 032 012 086 097 128 236 017 236 017 236 017 236 017 236 017'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des coefficients / Factors string : '193 157 113 095 094 199 111 159 194 216'" & vbCrLf & vbCrLf
  COardoise = COardoise & "Chaine des MC de correction / Error correction CW string : "
  Call SetLog(285)
  ChaineMC$ = "016 032 012 086 097 128 236 017 236 017 236 017 236 017 236 017"
  CoefRS$ = "193 157 113 095 094 199 111 159 194 216"
  NbRS% = Len(CoefRS$) / 4
  ReDim MCcorrection%(NbRS% - 1)
  Total% = 0
  For i% = 0 To Len(ChaineMC$) / 4 - 1
    Total% = Mid$(ChaineMC$, i% * 4 + 1, 3) Xor MCcorrection%(NbRS% - 1)
    For j% = NbRS% - 1 To 0 Step -1
      'Multiplication dans un champ de Galois / Galois field multiplication
      If Total% = 0 Then
        MCcorrection%(j%) = 0
      Else
        MCcorrection%(j%) = Mult(Total%, Mid$(CoefRS$, j% * 4 + 1, 3))
      End If
      If j% > 0 Then MCcorrection%(j%) = MCcorrection%(j%) Xor MCcorrection%(j% - 1)
    Next
  Next
  For i% = NbRS% - 1 To 0 Step -1
    COardoise = COardoise & Format(MCcorrection%(i%), "000") & " "
  Next
End Sub

Private Sub BTformat_Click()
  Dim Gn$, Data$, Result$, Mask$
  COardoise = "Chaine de format pour un code de niveau de correction L et utilisant le masque N 001 (Donnes = 01001)" & vbCrLf
  COardoise = COardoise & "Format string for a correction level L code and using mask N  001 (Data = 01001)" & vbCrLf & vbCrLf
  Gn$ = "10100110111"
  Data$ = "01001"
  Mask$ = "101010000010010"
  Result$ = Data$ & String$(10, "0")
  Result$ = SplitZeros$(Result$, 10)
  Do While Len(Result$) > 10
    Result$ = XORbin$(Result$, Gn$ & String$(Len(Result$) - Len(Gn$), "0"))
    Result$ = SplitZeros$(Result$, 10)
  Loop
  Result$ = XORbin$(Data$ & Result$, Mask$)
  COardoise = COardoise & Result$
End Sub

Private Sub BTversion_Click()
  Dim Gn$, Data$, Result$
  COardoise = "Chaine de version pour un code version 8 (Donnes = 001000)" & vbCrLf
  COardoise = COardoise & "Version string for version 8 code (Data = 001000)" & vbCrLf & vbCrLf
  Gn$ = "1111100100101"
  Data$ = "001000"
  Result$ = Data$ & String$(12, "0")
  Result$ = SplitZeros$(Result$, 12)
  Do While Len(Result$) > 12
    Result$ = XORbin$(Result$, Gn$ & String$(Len(Result$) - Len(Gn$), "0"))
    Result$ = SplitZeros$(Result$, 12)
  Loop
  COardoise = COardoise & Data$ & Result$
End Sub

Private Function Mult(a, b)
  'Multiplication dans un champ de Galois GF(255)
  'Multiplication in a Galois field GF (255)
  If (a = 0) Or (b = 0) Then Exit Function
  Mult = TAlog((TLog(a) + TLog(b)) Mod 255)
End Function

Private Sub SetLog(Mode%)
  Dim i%
  'Calcul des logs et antilogs permettant la multiplication dans un champ de Galois GF(255)
  'Calculation of logs and antilogs allowing multiplication in a Galois field GF (255)
  TLog(0) = -255
  TAlog(0) = 1
  For i% = 1 To 255
    TAlog(i%) = TAlog(i% - 1) * 2
    If (TAlog(i%) >= 256) Then TAlog(i%) = TAlog(i%) Xor Mode%
    TLog(TAlog(i%)) = i
  Next
End Sub

Private Function SplitZeros$(Chaine$, MiniLong%)
  Do While Left$(Chaine$, 1) = "0" And Len(Chaine$) > MiniLong%
    Chaine$ = Mid$(Chaine$, 2)
  Loop
  SplitZeros$ = Chaine$
End Function

Private Function XORbin$(Chaine1$, Chaine2$)
  Dim i%
  For i% = 1 To Len(Chaine1$)
    XORbin$ = XORbin$ & CStr(Mid$(Chaine1$, i%, 1) Xor Mid$(Chaine2$, i%, 1))
  Next
End Function
